#include <Servo.h>

//Declaring Variables
byte last_channel_1, last_channel_2, last_channel_3, last_channel_4, last_channel_5, last_channel_6;
int receiver_input_channel_1, receiver_input_channel_2, receiver_input_channel_3, receiver_input_channel_4, receiver_input_channel_5, receiver_input_channel_6;
unsigned long timer_1, timer_2, timer_3, timer_4, timer_5, timer_6;
Servo ElevonL;
Servo ElevonR;

//Setup routine
void setup(){
  ElevonL.attach(A1);
ElevonR.attach(A2);
  //Arduino (Atmega) pins default to inputs, so they don't need to be explicitly declared as inputs
  PCICR |= (1 << PCIE0);    // set PCIE0 to enable PCMSK0 scan
  PCMSK0 |= (1 << PCINT0);  // set PCINT0 (digital input 8) to trigger an interrupt on state change
  PCMSK0 |= (1 << PCINT1);  // set PCINT1 (digital input 9)to trigger an interrupt on state change
  PCMSK0 |= (1 << PCINT2);  // set PCINT2 (digital input 10)to trigger an interrupt on state change
  PCMSK0 |= (1 << PCINT3);  // set PCINT3 (digital input 11)to trigger an interrupt on state change
  PCMSK0 |= (1 << PCINT4);  // set PCINT3 (digital input 12)to trigger an interrupt on state change
  PCMSK0 |= (1 << PCINT5);  // set PCINT3 (digital input 13)to trigger an interrupt on state change
 Serial.begin(9600); 


}

//Main program loop
void loop(){
  
  print_signals();
}

//This routine is called every time input 8, 9, 10 or 11 changed state
ISR(PCINT0_vect){
  //Channel 1=========================================
  if(last_channel_1 == 0 && PINB & B00000001 ){         //Input 8 changed from 0 to 1
    last_channel_1 = 1;                                 //Remember current input state
    timer_1 = micros();                                 //Set timer_1 to micros()
  }
  else if(last_channel_1 == 1 && !(PINB & B00000001)){  //Input 8 changed from 1 to 0
    last_channel_1 = 0;                                 //Remember current input state
    receiver_input_channel_1 = micros() - timer_1;      //Channel 1 is micros() - timer_1
  }
  //Channel 2=========================================
  if(last_channel_2 == 0 && PINB & B00000010 ){         //Input 9 changed from 0 to 1
    last_channel_2 = 1;                                 //Remember current input state
    timer_2 = micros();                                 //Set timer_2 to micros()
  }
  else if(last_channel_2 == 1 && !(PINB & B00000010)){  //Input 9 changed from 1 to 0
    last_channel_2 = 0;                                 //Remember current input state
    receiver_input_channel_2 = micros() - timer_2;      //Channel 2 is micros() - timer_2
  }
  //Channel 3=========================================
  if(last_channel_3 == 0 && PINB & B00000100 ){         //Input 10 changed from 0 to 1
    last_channel_3 = 1;                                 //Remember current input state
    timer_3 = micros();                                 //Set timer_3 to micros()
  }
  else if(last_channel_3 == 1 && !(PINB & B00000100)){  //Input 10 changed from 1 to 0
    last_channel_3 = 0;                                 //Remember current input state
    receiver_input_channel_3 = micros() - timer_3;      //Channel 3 is micros() - timer_3
  }
  //Channel 4=========================================
  if(last_channel_4 == 0 && PINB & B00001000 ){         //Input 11 changed from 0 to 1
    last_channel_4 = 1;                                 //Remember current input state
    timer_4 = micros();                                 //Set timer_4 to micros()
  }
  else if(last_channel_4 == 1 && !(PINB & B00001000)){  //Input 11 changed from 1 to 0
    last_channel_4 = 0;                                 //Remember current input state
    receiver_input_channel_4 = micros() - timer_4;      //Channel 4 is micros() - timer_4
  }
  //Channel 5=========================================
  if(last_channel_5 == 0 && PINB & B00010000 ){         //Input 11 changed from 0 to 1
    last_channel_5 = 1;                                 //Remember current input state
    timer_5 = micros();                                 //Set timer_4 to micros()
  }
  else if(last_channel_5 == 1 && !(PINB & B00010000)){  //Input 11 changed from 1 to 0
    last_channel_5 = 0;                                 //Remember current input state
    receiver_input_channel_5 = micros() - timer_5;      //Channel 4 is micros() - timer_4
  }
  //Channel 6========================================
  if(last_channel_6 == 0 && PINB & B00100000 ){         //Input 13 changed from 0 to 1
    last_channel_6 = 1;                                 //Remember current input state
    timer_6 = micros();                                 //Set timer_6 to micros()
  }
  else if(last_channel_6 == 1 && !(PINB & B00100000)){  //Input 13 changed from 1 to 0
    last_channel_6 = 0;                                 //Remember current input state
    receiver_input_channel_6 = micros() - timer_6;      //Channel 6 is micros() - timer_6
  }
}
//Subroutine for displaying the receiver signals
void print_signals(){
  Serial.print("Roll:");
  
  Serial.print(receiver_input_channel_1);
  
  Serial.print("  Picth:");

  Serial.print(receiver_input_channel_2);
  
  Serial.print("  throtlle:");

  Serial.print(receiver_input_channel_3);
  
  Serial.print("  Yaw:");
  
  Serial.print(receiver_input_channel_4);
  Serial.print("  mode:");
  
  Serial.print(receiver_input_channel_5);
  Serial.print("  sprayer:");
  
  Serial.println(receiver_input_channel_6);
  ElevonL.write(receiver_input_channel_1);
   ElevonR.write(receiver_input_channel_2);
   
  
}
